searchData={"items":[{"type":"module","title":"Acl","doc":"# Acl\n\nACL or access control list is a list of permissions attached to a specific object for certain users.","ref":"Acl.html"},{"type":"module","title":"ACL guide - Acl","doc":"it has three essential Components Roles,Resources (handles as resource), and Rules.","ref":"Acl.html#module-acl-guide"},{"type":"module","title":"Roles - Acl","doc":"Roles (users/user groups) are entities you want to give or deny access to.\nyou can add a new role by\n\n\n\n    Acl.addRole(%{\"role\" => \"role\", \"parent\" => \"parent\"})\n\n\n\nin roles parent is optional, and you may choose to provide it or not.","ref":"Acl.html#module-roles"},{"type":"module","title":"Res - Acl","doc":"Res  are entities you want to give or deny access for. they can be anything real or arbitrary.\n\nyou can add a new res by\n\n\n\n    Acl.addRes(%{\"res\" => \"res\", \"parent\" => \"parent\"})\n\n\n\nin res parent is optional and you may choose to provide it or not.","ref":"Acl.html#module-res"},{"type":"module","title":"Rules - Acl","doc":"Rules are definition for your set of permissions. you can add rule by\n\n\n\n    addRule(role, res,  permission \\1, action \\nil ,condition \\1 )\n\n\nand you can check if a role or permission exists by\n\n\n\n    hasAccess(role, permission \\\"read\", res \\nil, action \\nil)\n\n\n\nvalid inputs for permission are \"POST\",\"GET\",\"PUT\" ,\"DELETE\",\"read\",\"write\",\"delete\",\"edit\". permissions have downward flow. i.e if you have defined permissions for a higher operation it automatically assigns them permissions for lower operations.\nlike \"edit\" grants permissions for all operations. their hierarchy is in this order\n\n\n\n    \"read\" < \"write\" < \"delete\" < \"edit\"\n    \"GET\" < \"POST\" < \"DELETE\" < \"PUT\"\n\n\n\nyou can use actions argument to define actions for your resources or not use thema t all and skip sending them in arguments. like i have a resource as maps and i can define actions like display/resize etc. now actions can be pages in a web application or can be tables for an api or can be functions inside a controller. you can be as creative as you wish\n\nand last argument condition is to define permission levels (0,1,2,3), and they map in this order.\n\n\n\n    0 -> \"none\"\n    1 -> \"self\"\n    2 -> \"related\"\n    3 -> \"all\"\n\n\n\nyou can add a res with empty string and it will be used as super resource. granting permission to that resource is equivalent to making a superadmin and any role who have access to this resource will have all permissions.","ref":"Acl.html#module-rules"},{"type":"module","title":"Acl.ACL","doc":"The ACL context.","ref":"Acl.ACL.html"},{"type":"function","title":"Acl.ACL.change_resource/2","doc":"Returns an `%Ecto.Changeset{}` for tracking resource changes.","ref":"Acl.ACL.html#change_resource/2"},{"type":"function","title":"Examples - Acl.ACL.change_resource/2","doc":"iex> change_resource(resource)\n    %Ecto.Changeset{data: %Resource{}}","ref":"Acl.ACL.html#change_resource/2-examples"},{"type":"function","title":"Acl.ACL.change_role/2","doc":"Returns an `%Ecto.Changeset{}` for tracking role changes.","ref":"Acl.ACL.html#change_role/2"},{"type":"function","title":"Examples - Acl.ACL.change_role/2","doc":"iex> change_role(role)\n    %Ecto.Changeset{data: %Role{}}","ref":"Acl.ACL.html#change_role/2-examples"},{"type":"function","title":"Acl.ACL.change_rule/2","doc":"Returns an `%Ecto.Changeset{}` for tracking rule changes.","ref":"Acl.ACL.html#change_rule/2"},{"type":"function","title":"Examples - Acl.ACL.change_rule/2","doc":"iex> change_rule(rule)\n    %Ecto.Changeset{data: %Rule{}}","ref":"Acl.ACL.html#change_rule/2-examples"},{"type":"function","title":"Acl.ACL.create_resource/1","doc":"Creates a resource.","ref":"Acl.ACL.html#create_resource/1"},{"type":"function","title":"Examples - Acl.ACL.create_resource/1","doc":"iex> create_resource(%{field: value})\n    {:ok, %Resource{}}\n\n    iex> create_resource(%{field: bad_value})\n    {:error, %Ecto.Changeset{}}","ref":"Acl.ACL.html#create_resource/1-examples"},{"type":"function","title":"Acl.ACL.create_role/1","doc":"Creates a role.","ref":"Acl.ACL.html#create_role/1"},{"type":"function","title":"Examples - Acl.ACL.create_role/1","doc":"iex> create_role(%{field: value})\n    {:ok, %Role{}}\n\n    iex> create_role(%{field: bad_value})\n    {:error, %Ecto.Changeset{}}","ref":"Acl.ACL.html#create_role/1-examples"},{"type":"function","title":"Acl.ACL.create_rule/1","doc":"Creates a rule.","ref":"Acl.ACL.html#create_rule/1"},{"type":"function","title":"Examples - Acl.ACL.create_rule/1","doc":"iex> create_rule(%{field: value})\n    {:ok, %Rule{}}\n\n    iex> create_rule(%{field: bad_value})\n    {:error, %Ecto.Changeset{}}","ref":"Acl.ACL.html#create_rule/1-examples"},{"type":"function","title":"Acl.ACL.delete_resource/1","doc":"Deletes a resource.","ref":"Acl.ACL.html#delete_resource/1"},{"type":"function","title":"Examples - Acl.ACL.delete_resource/1","doc":"iex> delete_resource(resource)\n    {:ok, %Resource{}}\n\n    iex> delete_resource(resource)\n    {:error, %Ecto.Changeset{}}","ref":"Acl.ACL.html#delete_resource/1-examples"},{"type":"function","title":"Acl.ACL.delete_role/1","doc":"Deletes a role.","ref":"Acl.ACL.html#delete_role/1"},{"type":"function","title":"Examples - Acl.ACL.delete_role/1","doc":"iex> delete_role(role)\n    {:ok, %Role{}}\n\n    iex> delete_role(role)\n    {:error, %Ecto.Changeset{}}","ref":"Acl.ACL.html#delete_role/1-examples"},{"type":"function","title":"Acl.ACL.delete_rule/1","doc":"Deletes a rule.","ref":"Acl.ACL.html#delete_rule/1"},{"type":"function","title":"Examples - Acl.ACL.delete_rule/1","doc":"iex> delete_rule(rule)\n    {:ok, %Rule{}}\n\n    iex> delete_rule(rule)\n    {:error, %Ecto.Changeset{}}","ref":"Acl.ACL.html#delete_rule/1-examples"},{"type":"function","title":"Acl.ACL.get_resource/1","doc":"","ref":"Acl.ACL.html#get_resource/1"},{"type":"function","title":"Acl.ACL.get_resource!/1","doc":"Gets a single resource.\n\nRaises `Ecto.NoResultsError` if the Acl resource does not exist.","ref":"Acl.ACL.html#get_resource!/1"},{"type":"function","title":"Examples - Acl.ACL.get_resource!/1","doc":"iex> get_resource!(123)\n    %Resource{}\n\n    iex> get_resource!(456)\n    ** (Ecto.NoResultsError)","ref":"Acl.ACL.html#get_resource!/1-examples"},{"type":"function","title":"Acl.ACL.get_role!/1","doc":"Gets a single role.\n\nRaises `Ecto.NoResultsError` if the Acl role does not exist.","ref":"Acl.ACL.html#get_role!/1"},{"type":"function","title":"Examples - Acl.ACL.get_role!/1","doc":"iex> get_role!(123)\n    %Role{}\n\n    iex> get_role!(456)\n    ** (Ecto.NoResultsError)","ref":"Acl.ACL.html#get_role!/1-examples"},{"type":"function","title":"Acl.ACL.get_rule!/1","doc":"Gets a single rule.\n\nRaises `Ecto.NoResultsError` if the Acl rule does not exist.","ref":"Acl.ACL.html#get_rule!/1"},{"type":"function","title":"Examples - Acl.ACL.get_rule!/1","doc":"iex> get_rule!(123)\n    %Rule{}\n\n    iex> get_rule!(456)\n    ** (Ecto.NoResultsError)","ref":"Acl.ACL.html#get_rule!/1-examples"},{"type":"function","title":"Acl.ACL.get_rule_by/1","doc":"","ref":"Acl.ACL.html#get_rule_by/1"},{"type":"function","title":"Acl.ACL.list_resources/0","doc":"Returns the list of resources.","ref":"Acl.ACL.html#list_resources/0"},{"type":"function","title":"Examples - Acl.ACL.list_resources/0","doc":"iex> list_resources()\n    [%Resource{}, ...]","ref":"Acl.ACL.html#list_resources/0-examples"},{"type":"function","title":"Acl.ACL.list_roles/0","doc":"Returns the list of roles.","ref":"Acl.ACL.html#list_roles/0"},{"type":"function","title":"Examples - Acl.ACL.list_roles/0","doc":"iex> list_roles()\n    [%Role{}, ...]","ref":"Acl.ACL.html#list_roles/0-examples"},{"type":"function","title":"Acl.ACL.list_rules/0","doc":"Returns the list of rules.","ref":"Acl.ACL.html#list_rules/0"},{"type":"function","title":"Examples - Acl.ACL.list_rules/0","doc":"iex> list_rules()\n    [%Rule{}, ...]","ref":"Acl.ACL.html#list_rules/0-examples"},{"type":"function","title":"Acl.ACL.update_resource/2","doc":"Updates a resource.","ref":"Acl.ACL.html#update_resource/2"},{"type":"function","title":"Examples - Acl.ACL.update_resource/2","doc":"iex> update_resource(resource, %{field: new_value})\n    {:ok, %Resource{}}\n\n    iex> update_resource(resource, %{field: bad_value})\n    {:error, %Ecto.Changeset{}}","ref":"Acl.ACL.html#update_resource/2-examples"},{"type":"function","title":"Acl.ACL.update_role/2","doc":"Updates a role.","ref":"Acl.ACL.html#update_role/2"},{"type":"function","title":"Examples - Acl.ACL.update_role/2","doc":"iex> update_role(role, %{field: new_value})\n    {:ok, %Role{}}\n\n    iex> update_role(role, %{field: bad_value})\n    {:error, %Ecto.Changeset{}}","ref":"Acl.ACL.html#update_role/2-examples"},{"type":"function","title":"Acl.ACL.update_rule/2","doc":"Updates a rule.","ref":"Acl.ACL.html#update_rule/2"},{"type":"function","title":"Examples - Acl.ACL.update_rule/2","doc":"iex> update_rule(rule, %{field: new_value})\n    {:ok, %Rule{}}\n\n    iex> update_rule(rule, %{field: bad_value})\n    {:error, %Ecto.Changeset{}}","ref":"Acl.ACL.html#update_rule/2-examples"},{"type":"module","title":"Acl.ACL.Resource","doc":"","ref":"Acl.ACL.Resource.html"},{"type":"module","title":"Acl.ACL.ResourceService","doc":"","ref":"Acl.ACL.ResourceService.html"},{"type":"function","title":"Acl.ACL.ResourceService.create/1","doc":"","ref":"Acl.ACL.ResourceService.html#create/1"},{"type":"module","title":"Acl.ACL.Role","doc":"","ref":"Acl.ACL.Role.html"},{"type":"module","title":"Acl.ACL.RoleService","doc":"","ref":"Acl.ACL.RoleService.html"},{"type":"function","title":"Acl.ACL.RoleService.create/1","doc":"","ref":"Acl.ACL.RoleService.html#create/1"},{"type":"module","title":"Acl.ACL.Rule","doc":"","ref":"Acl.ACL.Rule.html"},{"type":"function","title":"Acl.ACL.Rule.u_changeset/2","doc":"","ref":"Acl.ACL.Rule.html#u_changeset/2"},{"type":"module","title":"Acl.ACL.RuleService","doc":"","ref":"Acl.ACL.RuleService.html"},{"type":"function","title":"Acl.ACL.RuleService.addRule/5","doc":"","ref":"Acl.ACL.RuleService.html#addRule/5"},{"type":"function","title":"Acl.ACL.RuleService.allowRule/1","doc":"","ref":"Acl.ACL.RuleService.html#allowRule/1"},{"type":"function","title":"Acl.ACL.RuleService.checkRule/4","doc":"","ref":"Acl.ACL.RuleService.html#checkRule/4"},{"type":"function","title":"Acl.ACL.RuleService.condition/1","doc":"","ref":"Acl.ACL.RuleService.html#condition/1"},{"type":"function","title":"Acl.ACL.RuleService.denyRule/1","doc":"","ref":"Acl.ACL.RuleService.html#denyRule/1"},{"type":"function","title":"Acl.ACL.RuleService.formAclResponse/1","doc":"","ref":"Acl.ACL.RuleService.html#formAclResponse/1"},{"type":"function","title":"Acl.ACL.RuleService.getRule/1","doc":"","ref":"Acl.ACL.RuleService.html#getRule/1"},{"type":"function","title":"Acl.ACL.RuleService.iterateRules/4","doc":"","ref":"Acl.ACL.RuleService.html#iterateRules/4"},{"type":"function","title":"Acl.ACL.RuleService.permission/1","doc":"","ref":"Acl.ACL.RuleService.html#permission/1"},{"type":"extras","title":"Acl","doc":"# Acl\n\nACL or access control list is a list of permissions attached to a specific object for certain users.\nThis ACL is designed to be used in a phoenix (Elixir) project and handles all your permissions management.\n It requires following dependencies\n \n \n \n      {:ecto_sql, \"\\~> 3.10\"}  \n      {:jason, \"\\~> 1.2\"}\n      {:plug_cowboy, \"\\~> 1.0.0\"}\n      {:ex_doc, \">= 0.0.0\", only: :dev}\n      {:phoenix, \"\\~> 1.7.10\"}\n      {:phoenix_ecto, \"\\~> 4.4\"}\n      {:postgrex, \">= 0.0.0\"}\n      {:phoenix_html, \"\\~> 3.3\"}\n      {:phoenix_live_reload, \"\\~> 1.2\", only: :dev}\n      {:gettext, \"\\~> 0.20\"}\n      {:plug_cowboy, \"~> 2.5\"}","ref":"readme.html"},{"type":"extras","title":"Installation guide - Acl","doc":"To add ACL to your project simply add to your projects dependencies\n\n\n\n    {:acl, \"~> 0.5.0\"}\n\n\nand run `mix deps.get`\nthen you need to add :acl to your application in `mix.exs`\n\n    def application do\n    [\n      extra_applications: [:acl]\n    ]\n    end\n\nand also add configuration for :acl in your config file\n    \n    config :acl, Acl.Repo,\n       repo: MyApp.Repo\n    \nyou also need to run migrations for acl, which creates tables required for the acl, you can find migrations inside acl folder in your deps directory.\nor update your aliases function in mix.exs\n\n    \"ecto.setup\": [\"ecto.create\", \"acl.migrate\", \"ecto.migrate\", \"run priv/repo/seeds.exs\"],\n    \"acl.migrate\": [\"ecto.migrate --migrations-path deps/acl/priv/repo/migrations\"],\n    \"ecto.migrate\": [\"ecto.migrate --migrations-path ./\"],\n\n  * Run `mix setup` to install and setup dependencies\n  * Start Phoenix endpoint with `mix phx.server` or inside IEx with `iex -S mix phx.server`\n\nNow you can visit [`localhost:4000`](http://localhost:4000) from your browser.\n\nReady to run in production? Please [check our deployment guides](https://hexdocs.pm/phoenix/deployment.html).","ref":"readme.html#installation-guide"},{"type":"extras","title":"Learn more - Acl","doc":"* Official website: https://www.phoenixframework.org/\n  * Guides: https://hexdocs.pm/phoenix/overview.html\n  * Docs: https://hexdocs.pm/phoenix\n  * Forum: https://elixirforum.com/c/phoenix-forum\n  * Source: https://github.com/phoenixframework/phoenix","ref":"readme.html#learn-more"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,48]}}